// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.22.0
// source: tax-bill.sql

package generated

import (
	"context"

	"github.com/google/uuid"
)

const ownerTaxBillListDesc = `-- name: OwnerTaxBillListDesc :many
SELECT id, internal_id, run_id, owner_type, owner_id, owner_label, created_at
FROM digilab_demo_fbs.tax_bills
ORDER BY tax_bills.internal_id DESC
`

func (q *Queries) OwnerTaxBillListDesc(ctx context.Context) ([]*DigilabDemoFbsTaxBill, error) {
	rows, err := q.query(ctx, q.ownerTaxBillListDescStmt, ownerTaxBillListDesc)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsTaxBill{}
	for rows.Next() {
		var i DigilabDemoFbsTaxBill
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.RunID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const taxBillGet = `-- name: TaxBillGet :one
SELECT id, internal_id, run_id, owner_type, owner_id, owner_label, created_at
FROM digilab_demo_fbs.tax_bills
WHERE id=$1
`

func (q *Queries) TaxBillGet(ctx context.Context, id uuid.UUID) (*DigilabDemoFbsTaxBill, error) {
	row := q.queryRow(ctx, q.taxBillGetStmt, taxBillGet, id)
	var i DigilabDemoFbsTaxBill
	err := row.Scan(
		&i.ID,
		&i.InternalID,
		&i.RunID,
		&i.OwnerType,
		&i.OwnerID,
		&i.OwnerLabel,
		&i.CreatedAt,
	)
	return &i, err
}

const taxBillListAsc = `-- name: TaxBillListAsc :many
SELECT objs.id, objs.internal_id, objs.run_id, objs.owner_type, objs.owner_id, objs.owner_label, objs.created_at FROM (
    SELECT id, internal_id, run_id, owner_type, owner_id, owner_label, created_at
    FROM digilab_demo_fbs.tax_bills
    WHERE tax_bills.internal_id > (
        SELECT sub_qry.internal_id
        FROM digilab_demo_fbs.tax_bills as sub_qry
        WHERE sub_qry.id=$1
    )
    ORDER BY tax_bills.internal_id ASC
    LIMIT $2
) objs ORDER BY objs.internal_id DESC
`

type TaxBillListAscParams struct {
	ID    uuid.UUID
	Limit int32
}

func (q *Queries) TaxBillListAsc(ctx context.Context, arg *TaxBillListAscParams) ([]*DigilabDemoFbsTaxBill, error) {
	rows, err := q.query(ctx, q.taxBillListAscStmt, taxBillListAsc, arg.ID, arg.Limit)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsTaxBill{}
	for rows.Next() {
		var i DigilabDemoFbsTaxBill
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.RunID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const taxBillListDesc = `-- name: TaxBillListDesc :many
SELECT id, internal_id, run_id, owner_type, owner_id, owner_label, created_at
FROM digilab_demo_fbs.tax_bills
WHERE tax_bills.internal_id < COALESCE((
    SELECT internal_id
    FROM digilab_demo_fbs.tax_bills as sub_qry
    WHERE sub_qry.id=$1
), $2)
ORDER BY tax_bills.internal_id DESC
LIMIT $3
`

type TaxBillListDescParams struct {
	ID         uuid.UUID
	InternalID int32
	Limit      int32
}

func (q *Queries) TaxBillListDesc(ctx context.Context, arg *TaxBillListDescParams) ([]*DigilabDemoFbsTaxBill, error) {
	rows, err := q.query(ctx, q.taxBillListDescStmt, taxBillListDesc, arg.ID, arg.InternalID, arg.Limit)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsTaxBill{}
	for rows.Next() {
		var i DigilabDemoFbsTaxBill
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.RunID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const taxBillOwner = `-- name: TaxBillOwner :many
SELECT id, internal_id, run_id, owner_type, owner_id, owner_label, created_at
FROM digilab_demo_fbs.tax_bills
WHERE tax_bills.owner_id = $1
AND tax_bills.internal_id < COALESCE((
    SELECT internal_id
    FROM digilab_demo_fbs.tax_bills as sub_qry
    WHERE sub_qry.id=$2
), $3)
ORDER BY tax_bills.internal_id DESC
LIMIT $4
`

type TaxBillOwnerParams struct {
	OwnerID    uuid.UUID
	ID         uuid.UUID
	InternalID int32
	Limit      int32
}

func (q *Queries) TaxBillOwner(ctx context.Context, arg *TaxBillOwnerParams) ([]*DigilabDemoFbsTaxBill, error) {
	rows, err := q.query(ctx, q.taxBillOwnerStmt, taxBillOwner,
		arg.OwnerID,
		arg.ID,
		arg.InternalID,
		arg.Limit,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsTaxBill{}
	for rows.Next() {
		var i DigilabDemoFbsTaxBill
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.RunID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
